import java.io.*;
import java.util.*;

public class NameRecall_Bowen {
  static ArrayList< ArrayList< TreeMap<State, Integer> >> dp;
  static int n, m;
  static int[] as;
  static int ans;
  static int INF = (int)1e9;

  public static void main(String[] args) throws IOException {
    Scanner scan = new Scanner(System.in);
    n = scan.nextInt();
    m = scan.nextInt();
    as = new int[m];
    for (int i = 0; i < m; i++) {
        as[i] = scan.nextInt();
        as[i] = Math.min(as[i], n - as[i]);
    }
    dp = new ArrayList< ArrayList< TreeMap<State, Integer> >>();
    for (int i = 0; i <= m; i++) {
      ArrayList<TreeMap<State, Integer>> row = new ArrayList<TreeMap<State, Integer>>();
      dp.add(row);
      for (int j = 0; j <= n; j++) row.add(new TreeMap<State, Integer>());
    }

    System.out.println(solve(new ArrayList<Integer>(Arrays.asList(n)), new ArrayList<Integer>(), 0, as[0], 0, 0));
    scan.close();
  }

  static void insertSort(ArrayList<Integer> vals, int v) {
    vals.add(v);
    int i = (int)vals.size() - 1;
    while (i > 0 && vals.get(i - 1) < vals.get(i)) {
      int t = vals.get(i);
      vals.set(i, vals.get(i - 1));
      vals.set(i - 1, t);
      --i;
    }
  }

  static int solve(ArrayList<Integer> groups, ArrayList<Integer> splitGroups, int i, int a, int used, int uniq) {
    if ((groups.isEmpty() && splitGroups.isEmpty()) || i == m) return uniq;
    int b = n - used - a;
    State groupKey = new State(groups, splitGroups);
    if (dp.get(i).get(a).containsKey(groupKey)) return dp.get(i).get(a).get(groupKey);
    if (groups.isEmpty()) {
      int newVal = solve(splitGroups, new ArrayList<Integer>(), i + 1, (i + 1 < m ? as[i + 1] : 0), 0, uniq);
      dp.get(i).get(a).put(groupKey, newVal);
      return newVal;
    }
    int gSize = groups.get((int)groups.size() - 1);
    int sol = -INF;
    int gCnt = 1;
    while (gCnt < groups.size() && groups.get((int)groups.size() - 1 - gCnt) == gSize) gCnt++; // gCnt groups of the same size
    ArrayList<Integer> newGroups = new ArrayList<Integer>(groups);
    ArrayList<Integer> newSplitGroups = new ArrayList<Integer>(splitGroups);
    for (int t = 0; t < gCnt; t++) {
      newGroups.remove((int)newGroups.size() - 1);
      insertSort(newSplitGroups, gSize);
    }
    // don't split all groups of this size
    for (int ca = 0; ca <= gCnt; ca++) {
      int ua = ca * gSize, ub = (gCnt - ca) * gSize;
      if (ua > a) break;
      if (ub > b) continue;
      sol = Math.max(sol, solve(newGroups, newSplitGroups, i, a - ua, used + gCnt * gSize, uniq));
    }
    // split the smallest group
    newGroups = new ArrayList<Integer>(groups);
    newGroups.remove((int)newGroups.size() - 1);
    for (int p = 1; p < gSize; p++) {
      int q = gSize - p;
      if (p > a) break;
      if (q > b) continue;
      newSplitGroups = new ArrayList<Integer>(splitGroups);
      int newUniq = uniq + (p == 1 && q == 1 ? 2 : (p == 1 || q == 1 ? 1 : 0));
      if (p > 1) insertSort(newSplitGroups, p);
      if (q > 1) insertSort(newSplitGroups, q);
      sol = Math.max(sol, solve(newGroups, newSplitGroups, i, a - p, used + gSize, newUniq));
    }
    dp.get(i).get(a).put(groupKey, sol);
    return sol;
  }

  static int compareList(ArrayList<Integer> a, ArrayList<Integer> b) {
    int sz = Math.min(a.size(), b.size());
    for (int i = 0; i < sz; i++) {
      if (a.get(i) < b.get(i)) return -1;
      if (a.get(i) > b.get(i)) return 1;
    }
    if (a.size() < b.size()) return -1;
    if (a.size() > b.size()) return 1;
    return 0;
  }

  static class State implements Comparable<State> {
    ArrayList<Integer> groups;
    ArrayList<Integer> splitGroups;
    public State(ArrayList<Integer> _groups, ArrayList<Integer> _splitGroups) {
      groups = new ArrayList<Integer>(_groups);
      splitGroups = new ArrayList<Integer>(_splitGroups);
    }

    @Override
    public int compareTo(State o) {
      int a = compareList(groups, o.groups);
      if (a != 0) return a;
      return compareList(splitGroups, o.splitGroups);
    }
  }
}
