#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int, int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9;
#define MAXN 32

int n, m;
VI as;
map<pair<VI,VI>, int> dp[MAXN][MAXN]; // [day index][#a]
void insertSort(VI &vals, int v) {
	vals.push_back(v);
	int i = (int)vals.size() - 1;
	while (i > 0 && vals[i - 1] < vals[i]) {
        swap(vals[i], vals[i-1]);
        --i;
    }
}

int solve(VI groups, VI splitGroups, int i, int a, int used, int uniq) {
	if ((groups.empty() && splitGroups.empty()) || i == as.size()) return uniq;
	int b = n - used - a;
	//if (a > b) swap(a, b);

	pair<VI, VI> groupKey = make_pair(groups, splitGroups);
	auto it = dp[i][a].find(groupKey);
	if (it != dp[i][a].end()) return it->second;
	if (groups.empty()) return dp[i][a][groupKey] = solve(splitGroups, VI(), i + 1, (i + 1 < m ? as[i + 1] : 0), 0, uniq);

	int gSize = groups.back();

	int sol = -INF;
	int gCnt = 1;
	while (gCnt < groups.size() && groups[(int)groups.size() - 1 - gCnt] == gSize) gCnt++; // gCnt groups of the same size

	VI newGroups, newSplitGroups;
	newGroups = groups; newSplitGroups = splitGroups;
	REP(t, 0, gCnt) {
		newGroups.pop_back();
		insertSort(newSplitGroups, gSize);
	}
	// don't split all groups of this size
	REP(ca, 0, gCnt + 1) {
		int ua = ca * gSize, ub = (gCnt - ca) * gSize;
		if (ua > a) break;
		if (ub > b) continue;
		sol = max(sol, solve(newGroups, newSplitGroups, i, a - ua, used + gCnt * gSize, uniq));
	}

	// split the smallest group
	newGroups = groups;
	newGroups.pop_back();
	REP(p, 1, gSize) {
		int q = gSize - p;
		if (p > a) break;
		if (q > b) continue;
		newSplitGroups = splitGroups;
		int newUniq = uniq + (p == 1 && q == 1 ? 2 : (p == 1 || q == 1 ? 1 : 0));
		if (p > 1) insertSort(newSplitGroups, p);
		if (q > 1) insertSort(newSplitGroups, q);
		sol = max(sol, solve(newGroups, newSplitGroups, i, a - p, used + gSize, newUniq));
	}
	return dp[i][a][groupKey] = sol;
}

int main() {
  as.clear();
  REP(i, 0, MAXN) REP(a, 0, MAXN) dp[i][a].clear();

  cin >> n >> m;
  REP(i, 0, m) {
    int a;
    cin >> a;
    //if (a > n - a) a = n - a;
    as.push_back(a);
  }

  //sort(as.begin(), as.end());
  cout << solve(VI({ n }), VI(), 0, as[0], 0, 0) << endl;
	return 0;
}
