import java.io.*;
import java.util.*;

public class NameRecall_Arknave {
    static Map<List<Integer>, Integer> memo;
    static int n;
    static int[] a;
    static int ans;

    public static void main(String[] args) throws IOException {
        Scanner scan = new Scanner(System.in);
        n = scan.nextInt();
        int m = scan.nextInt();
        a = new int[m];
        for (int i = 0; i < m; i++) {
            a[i] = scan.nextInt();
            a[i] = Math.min(a[i], n - a[i]);
        }
        Arrays.sort(a);
        for (int s = 0, e = m - 1; s < e; ++s, --e) {
            int t = a[s];
            a[s] = a[e];
            a[e] = t;
        }

        memo = new HashMap<>();

        List<Integer> base = new ArrayList<>();
        base.add(n);
        dfs(base, new ArrayList<>(), 0, 0, a[0], 0);
        System.out.println(ans);
    }

    private static void dfs(
        List<Integer> partition,
        List<Integer> follow,
        int day,
        int partitionIndex,
        int rem,
        int uniq
    ) {
        if (ans == n) {
            return;
        }
        if (partitionIndex == partition.size()) {
            if (rem > uniq) return;
            List<Integer> cleaned = new ArrayList<>(follow);
            int cur = score(cleaned);
            ans = Math.max(ans, cur);
            if (day + 1 < a.length) {
                Collections.sort(cleaned);
                dfs(cleaned, new ArrayList<>(), day + 1, 0, a[day + 1], cur);
            }
            return;
        }

        if (partitionIndex == 0) {
            Integer firstDay = memo.get(partition);
            if (firstDay != null && firstDay <= day) {
                return;
            } else {
                memo.put(partition, day);
            }
        }

        int v = partition.get(partitionIndex);
        for (int k = 0; k <= Math.min(rem, v); k++) {
            int pops = 0;
            if (k > 1) {
                follow.add(k);
                pops++;
            }
            if (v - k > 1) {
                follow.add(v - k);
                pops++;
            }

            dfs(partition, follow, day, partitionIndex + 1, rem - k, uniq);

            while (pops-- > 0) {
                follow.remove(follow.size() - 1);
            }
        }
    }

    private static int score(List<Integer> partition) {
        int res = n;
        for (int x : partition) {
            res -= x;
        }

        return res;
    }
}
