#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
using vi = vector<int>;

ostream& operator<<(ostream& os, const vi& v) {
    if (v.empty()) return os << "{}";
    os << "{" << v[0];
    for (int i = 1; i < v.size(); ++i) {
        cout << ", " << v[i];
    }
    return os << "}";
}

constexpr int MAX_EMPLOYEES = 32;
constexpr int MAX_DAYS = 11;
int num_employees, num_days;
int orders[MAX_DAYS];
int ans = 0;

set<vi> follow;
map<vi, set<vi>> follows[MAX_EMPLOYEES][MAX_EMPLOYEES];
vi cur;

void dfs1(const vi& partition, int idx, int k, int buf) {
    if (idx == partition.size()) {
        if (k <= buf) {
            vi dupe(begin(cur), end(cur));
            sort(begin(dupe), end(dupe));
            follow.insert(dupe);
        }
        return;
    }

    for (int i = 0; i <= min(k, partition[idx]); ++i) {
        int pushes = 0;
        if (i > 1) {
            cur.push_back(i);
            ++pushes;
        }
        if (partition[idx] - i > 1) {
            cur.push_back(partition[idx] - i);
            ++pushes;
        }

        dfs1(partition, idx + 1, k - i, buf);

        while (pushes-- > 0)
            cur.pop_back();
    }
}

map<vi, int> earliest;

// keep partitions sorted
void dfs0(const vi& partition, int day) {
    if (ans == num_employees)
        return;

    {
        auto it = earliest.find(partition);
        int best = it == end(earliest) ? MAX_DAYS + 1 : it->second;
        if (day >= best) return;
    }

    earliest[partition] = day;

    int uniq = num_employees;
    for (int x : partition) {
        uniq -= x;
    }
    ans = max(ans, uniq);
    // cout << "day " << day << " partition " << partition << " uniq " << uniq << '\n';
    if (day == num_days) {
        return;
    }

    // for each group:
    // ignore it, or split it into x and n - x and divide by day
    // there's a _lot_ of ways to do this?
    auto it = follows[orders[day]][uniq].find(partition);
    if (it == end(follows[orders[day]][uniq])) {
        follow.clear();
        dfs1(partition, 0, orders[day], uniq);
        it = follows[orders[day]][uniq].insert({partition, follow}).first;
    }

    for (auto& v : it->second) {
        dfs0(v, day + 1);
    }
}

int main() {
    cin >> num_employees >> num_days;
    for (int i = 0; i < num_days; ++i) {
        cin >> orders[i];
        orders[i] = min(orders[i], num_employees - orders[i]);
    }
    sort(orders, orders + num_days, greater<int>()); 

    ans = 0;
    dfs0({num_employees}, 0);

    cout << ans << '\n';

    return 0;
}
